/*
 * Ben NanoNote stage 2 payload test.
 *
 * Copyright (C) Wolfgang Spraul <wolfgang@sharism.cc>
 * Copyright (C) 2015, 2016 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "board-specific.h"

#include "irq.h"
#include "lcd.h"
#include "cpu.h"

void c_main(void)
{
	volatile int started;

	init_tlb();
	flush_cache_all();

	/* The actual work. */

	started = is_started();

	if (!started)
	{
		gpio_init2();
		cpm_init();
		rtc_init();
		timer_init();
	}

	lcd_init();
	handle_error_level();
	irq_init();

	start_task();

	while (1) asm volatile("wait");
}
